<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
	$reportName = 'Services and Repairs Cost By Vehicle';
	$reportVariables[] = '$tooltipSection = "report_rscostbyvehicle";';
	$reportVariables[] = 'echo form_checkbox("usedatefilter", "usedatefilter", false, $label="Use Dates",$tooltipSection);';
	$reportVariables[] = 'echo form_date_select("startDate", "startDate", "", "Start Date:",$tooltipSection);';
	$reportVariables[] = 'echo form_date_select("endDate", "endDate", "", "End Date:",$tooltipSection);';
	//$reportVariables[] = 'echo form_checkbox("usecarfilter", "usecarfilter", false, $label="Use Vehicles",$tooltipSection);';
	$reportVariables[] = 'echo form_vehicle_select("vehicleK[]", "vehicleK", 0, true, 10,"Select specific vehicles to report on:<br /><br .>(* = Archived vehicle):",$tooltipSection);';
	$reportVariables[] = 'echo form_site_select("siteFK", "siteFK", "", "Location",$tooltipSection);';
	$reportVariables[] = 'echo form_checkbox("usearchived", "usearchived", false, $label="Include Archived Vehicles",$tooltipSection);';
	
	$useDateFilter = (isset($p->usedatefilter) && $p->usedatefilter==1)?true:false;
	$useCarFilter = (isset($p->usecarfilter) && $p->usecarfilter==1)?true:false;
	$startDate = isset($p->startDate)?$p->startDate:false;
	$endDate = isset($p->endDate)?$p->endDate:'';
	$vehicleIds = isset($p->vehicleK)?$p->vehicleK:'';	
	$useArchived = (isset($p->usearchived) && $p->usearchived==1)?true:false;
	$location = isset($p->siteFK)?$p->siteFK:''; 
	
	$conditions = array();
	
	$dateconditions = array();
	
	if($useDateFilter){
		
		
		if($startDate){
			$dateconditions[] = ' sr.actualDate >="'.date('Y-m-d h:i:s', strtotime($startDate.' 00:00:00')).'"';
		}
		
		if($endDate){
			$dateconditions[] = ' sr.actualDate<="'.date('Y-m-d h:i:s', strtotime($endDate.' 00:00:00')).'"';
		}
		
	}
	
	//if($useCarFilter){
		if($vehicleIds){
			$conditions[] = 'vehicle.vehicleK IN('.implode(',', $vehicleIds).')';
		}
	//}
	
	if(!$useArchived && !$vehicleIds){
		$conditions[]  = '  (archived = 0) ';
	}
	
	if($location>0){
		$conditions[] = ' (siteFK = '. $location .') ';
	}
	
	$sql = "SELECT 
											vehicle.vehicleK as 'Vehicle ID', 
											manuf.name as 'Manufacturer', 
											model.modelname as 'Model', 
											tblSite.name as 'Location'
									FROM 
											tblVehicle vehicle 
													INNER JOIN 
											tblModel model ON vehicle.modelFK = model.modelK 
													INNER JOIN 
											tblManufacturer manuf ON model.manufacturerFK = manuf.manufacturerK 
											INNER JOIN tblSite ON siteK = siteFK
											";
											
	if(count($conditions)>0){
		$sql.=' WHERE ';
		for($i=0;$i<count($conditions);$i++){
			if($i>0){
				$sql .= ' AND ';
			}
			$sql .= $conditions[$i];
		}
	}											
											
	$sql .= " GROUP BY vehicle.vehicleK";
	
	if(!$res = dbQuery($sql)){
		die('SQL Error: '.dbError());
	}else{
			$vehiclecosts['ID'] = 'Vehicle ID';			
			$vehiclecosts['Registration'] = 'Registration Number';
			$vehiclecosts['Location'] = 'Location';
			$vehiclecosts['Manufacturer'] = 'Manufacturer';
			$vehiclecosts['Model'] = 'Model';

			$vehiclecosts['A'] = 'Service Costs';
			$vehiclecosts['B'] = 'Repair Costs';
			$vehiclecosts['C'] = 'Total Costs';
			
$reportArray[] = $vehiclecosts;
	
	while($temp = dbFetchAssoc($res)){
			$vehiclecosts['ID'] = $temp['Vehicle ID'];			
			$vehiclecosts['Registration'] = getRegoNumberByVehicleK($vehiclecosts['ID']);
			$vehiclecosts['Location'] = $temp['Location'];
			$vehiclecosts['Manufacturer'] = $temp['Manufacturer'];
			$vehiclecosts['Model'] = $temp['Model'];
			
			$vehiclecosts['A'] = getserviceCosts($vehiclecosts['ID'], $dateconditions);
			$vehiclecosts['B'] = getRepairsCosts($vehiclecosts['ID']);
			$vehiclecosts['C'] = number_format(round($vehiclecosts['A'] + $vehiclecosts['B'], 2), 2);
			
			$reportArray[] = $vehiclecosts;
		}	
	
	}
	
	$customreport = true;
	
	
	function getRegoNumberByVehicleK($svehicleK) {
		
		$sql1="Select number from tblRego where vehicleFK =" . $svehicleK ." order by expires desc LIMIT 0, 1" ;
		$return = "";
		if(!$res = dbQuery($sql1)){
			die('SQL Error: '.dbError());
		}else{
			if(dbNumRows($res)>0){
				$item= dbFetchAssoc($res);
				$return = $item['number'];				
			}
			}	
	
	return $return;	
	}
	
	function getserviceCosts($svehicleK, $dateconditions) {
		
		$sql1 = '';
		$sql1 = " SELECT SUM(CASE WHEN s.cost IS NULL THEN 0 ELSE s.cost END) as 'ServiceCost' FROM tblServiceRepairs sr";
		$sql1 .= " INNER JOIN tblService s ON s.serviceRepairFK = sr.servicerepairsPK where vehicleFK = " . $svehicleK;

		
		if(count($dateconditions)>0){
			$sql1.=' AND ';
			for($i=0;$i<count($dateconditions);$i++){
				if($i>0){
					$sql1 .= ' AND ';
				}
				$sql1 .= $dateconditions[$i];
			}
		}		
	
	
		$return = "0";
		if(!$res = dbQuery($sql1)){
			die('SQL Error: '.dbError());
		}else{
			if(dbNumRows($res)>0){
				$item= dbFetchAssoc($res);
				$return = $item['ServiceCost'];				
			}
			}	
	
	return $return;	
	}
	
	function getRepairsCosts($svehicleK){
		
		$sql1 = '';
		$sql1 = " SELECT SUM(CASE WHEN r.cost IS NULL THEN 0 ELSE r.cost END) as 'RepairCost' FROM tblServiceRepairs sr";
		$sql1 .= " INNER JOIN tblRepairs r ON r.serviceRepairFK = sr.servicerepairsPK where vehicleFK = " . $svehicleK;

		$return = "0";
		if(!$res = dbQuery($sql1)){
			die('SQL Error: '.dbError());
		}else{
			if(dbNumRows($res)>0){
				$item= dbFetchAssoc($res);
				$return = $item['RepairCost'];
			}				
		}
	
	return $return;	
	}
	
	
?>