<?php
 /**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  include_once('c_table.php');
  include_once('c_generic.php');
  include_once('form_functions.php');
  
	if(isset($p->cancel_manufacturer)){
		redirect('/?a=general/manufacturers');
	}  

  global $invalidFields;
  $man = new cGeneric('tblManufacturer', 'manufacturerK');
  if(arg(2)) {
    $man->loadById(arg(2));
  }
  
	if(isset($p->op) && $p->op == 'save_manufacturer') {
		if(isset($p->submit_manufacturer)) {
			if(validateManufacturer()) {
				$auditType = ((isset($p->manufacturerK) && $p->manufacturerK>0)?2:1);
				if($auditRowId = dbWritePosted('tblManufacturer', 'manufacturerK')) {
					$audit = new c_Audit('tblManufacturer','manufacturerK', $user->userK, $auditType);
					$audit->loadRow($auditRowId);
					$audit->runAudit();
					redirect("/?a=general/manufacturers");
				}
			}
		} else if(isset($p->delete_manufacturer)) {
			$auditType=3;
			$auditRowId = $p->manufacturerK;
			$audit = new c_Audit('tblManufacturer','manufacturerK', $user->userK, $auditType);					
			$audit->loadRow($auditRowId);
			$audit->runAudit();
			if(dbDeleteRow('tblManufacturer', 'manufacturerK', $p->manufacturerK)) {
				redirect('/?a=general/manufacturers');
			}
		}
	}

	function validateManufacturer(){
		global $p, $invalidFields;
		
		//get field lengths
		//$dbFieldSizes = dbGetFieldSizes('tblManufacturer');
		
		//manufacturer name
		if(strlen(trim($p->name))==0){
			$invalidFields['name'] = "Please enter a manufacturer name";	
		}else{
			if(strlen(trim($p->name)) < 255) {
				$sql = 'SELECT count(*) as lcount FROM tblManufacturer WHERE name="'.$p->name.'"';
				if(isset($p->manufacturerK) && $p->manufacturerK>0){
					$sql.=' AND manufacturerK !='.$p->manufacturerK;
				}
				$res = dbQuery($sql);
				if(!$res) {
					debug(dbError($sql));
				} else {
					if(!$lCount = dbFetchAssoc($res)){
						//debug(dbError($sql));
					}else{
						if($lCount['lcount']>0){
							$invalidFields['name'] = 'The Manufacturer Name supplied already Exists';
						}
						dbFreeResult($res);
					}
				}

				if(is_numeric($p->name)){
					$invalidFields['name'] = 'Manufacturer Name cannot contain numbers.';
				}
			}else{
				$invalidFields['name']='Name exceeds the maximum string length of '.$dbFieldSizes['name'];
			}
		}
		
		if(is_array($invalidFields) && count($invalidFields)>0){
			return false;
		}else{
			return true;
		}
	}
?>

<div class='pageSubTitle'>
  Manufacturer Administration
</div>

<table cellpadding='10' cellspacing='0' border='0' width='100%'><tr>
<td valign='top' width='50%'>

<?php
  
  $sql  = 'select m.* ';
  $sql .= '      ,u.username ';
  $sql .= 'from tblManufacturer m ';
  $sql .= 'left outer join tblUser u on (u.userK = m.modified_by) ';
  $sql .= ' ORDER BY m.name';
  $res = dbQuery($sql);
  if(!$res) {
    debug(dbError($sql));
  } else {
    $columns = array(
      array('Manufacturer', 'name'),
      array('Last Modified', 'modified_date'),
      array('Modified By', 'username'),
      array('&nbsp;','history')
    );
    $tbl = new cTable($columns);
    echo "<b>Manufacturers</b><br/>";
    $tbl->drawHeader();
    while($row = dbFetchAssoc($res)) {
		 $row['modified_date'] = date(DATE_FORMAT, strtotime($row['modified_date']));
    	$row['history'] = '<a href="showhistory.php?tableName=tblManufacturer&tableKeyName=manufacturerK&id='.$row['manufacturerK'].'" target="_blank">History</a>';
      $tbl->drawRow($row, '?a=general/manufacturers/'.$row['manufacturerK']);
    }
    $tbl->drawFooter();
  }

?>
</td>
<td valign='top'>
<? if(arg(2)) { ?>
  <b>Edit Manufacturer</b><br/>
<? } else { ?>
  <b>New Manufacturer</b>
<? } ?>
<?
  if(is_array($invalidFields) && count($invalidFields) > 0) {
    echo "<br/><br/>Failed to save manufacturer details, please correct the following:<br/>";
    echo "<ul>";
    foreach($invalidFields as $k=>$v) {
      if(strlen($v) > 0) {
        echo "<li>".$v."</li>";
      }
    }
    echo "</ul><br/>";
  }
?>
<? $tooltipSection = 'general_manufacturers';  ?>
  <?= form_start('manufacturer_edit', '/?a=general/manufacturers', 'post'); ?>
    <?= form_hidden('op', 'save_manufacturer'); ?>
    <?= form_hidden('manufacturerK', ((strlen(trim(arg(2)))!=0)?$man->get('manufacturerK'):(isset($p->manufacturerK)?$p->manufacturerK:''))); ?>
    <?= form_hidden('modified_date', 'now()'); ?>
    <?= form_hidden('modified_by', sess_get('userK')); ?>
    <?= form_textinput('name', 'name', ((strlen(trim(arg(2)))!=0)?$man->get('name'):(isset($p->name)?stripslashes($p->name):'')), "Manufacturer", 180, 45,$tooltipSection, true);  ?>
    <br/>
    <?
      $buttons = array();
      $buttons[] = form_submit('submit_manufacturer', ' Submit ');
      if(count($invalidFields)>0 || arg(2)){
      	$buttons[] = form_submit('cancel_manufacturer', ' Reset ');
      }else{
      	$buttons[] = form_reset('reset_manufacturer', ' Reset ');
      }
	  if(defined('GENERAL_DELETE') && GENERAL_DELETE == True) {
		  if(arg(2)) {
	  $buttons[] = form_submit('delete_manufacturer', ' Delete ', 'color:#a00;');
		  }
	  }
      echo form_button_bar($buttons);
    ?>
  <?= form_end(); ?>
</td>
</tr></table>
