<?php
/**
*@package OurFleet
*@copyright Copyright 2006 Web Matrix Pty Ltd & e-fficiency Business Solutions
*@version 1.0 
*/

/**
*@version 1.0
*/
  
  $usersPerPage = 25;
  
  include_once('c_pager.php');
  include_once('c_table.php');
  
  $pager = new cPager($usersPerPage);
  
?>

<div class='pageTitle'>
  User Administration - <a href='?a=edituser/0'>New User</a>
</div>
<?php

  $sql = 'select count(*) as numUsers from tblUser ';
  $res = dbQuery($sql);
  if(!$res) {
    debug(dbError($sql));
    $pager->disable();
  } else {
    $row = dbFetchAssoc($res);
    dbFreeResult($res);
    $pager->setMax($row['numUsers']);
  }

  $accessLevels = access_load_levels();
  
  $sql  = 'select u.userK, u.username, u.email, u.lastlogin, u.lastlogin_ip, a.level as access, unix_timestamp(lastlogin) as lastlogin_ts, ';
  $sql .= '       (case when (e.employeeK is not null) then 1 else 0 end) as isEmployee, ';
  $sql .= '       concat(e.lastname, ", ", e.firstname) as employeeName ';
  $sql .= 'from tblUser u ';
  $sql .= 'inner join tblAccess a on (a.accessK = u.accessFK) ';
  $sql .= 'left outer join tblEmployee e on (e.employeeK = u.employeeFK) ';
  $sql .= 'limit '.$pager->start.','.$pager->perPage.' ';

  $res = dbQuery($sql);
  if(!$res) {
    debug(dbError($sql));
  } else {
    if(dbNumRows($res) > 0) {
      $columns = array(
        array('Username',   'username'),
        array('Employee',   'employeeName'),
        array('Email',      'email'),
        array('Last Login', 'lastlogin'),
        array('Login From', 'lastlogin_ip')
      );
      $tbl = new cTable($columns);
      $tbl->drawHeader();
      while($row = dbFetchAssoc($res)) {
      	$row['lastlogin'] = (!empty($row['lastlogin'])) ? date(DATE_FORMAT, strtotime($row['lastlogin'])) : 'Never Logged In';
		$row['lastlogin_ip'] = (!empty($row['lastlogin_ip'])) ? $row['lastlogin'] : 'None';
        $tbl->drawRow($row, "?a=edituser/".$row['userK']);
      }
      $tbl->drawFooter();
      $pager->draw(6);
    } else {
      // no users
      echo "No Users.";
    }
  }
?>
